unit Player4;

interface
uses Types;
      
type TMyPlayer = object(TDefaultPlayer)
			constructor Init;
			destructor Done;
			
			{ zaciatok kazdej hry }
			procedure InitGame(id: integer); virtual;
					   
			{ znovunarodenie (i.e. po InitGame a po kazdom zozrati }
			procedure Born(I_see: Tview); virtual;
			
			{ po zozrati }
			procedure Eaten(I_saw: Tview); virtual;
			
			{ jeden tah }
			procedure MakeMove(I_see: Tview; var command: integer); virtual;

		      end;
     PMyPlayer = ^TMyPlayer;


implementation

{$LINKLIB c}
{$LINK player4c}

procedure cplayer_InitGame(id: longint); cdecl; external name 'cplayer_InitGame';
procedure cplayer_Born(I_see: Tview); cdecl; external name 'cplayer_Born';
procedure cplayer_Eaten(I_saw: Tview); cdecl; external name 'cplayer_Eaten';
function cplayer_MakeMove(I_see: Tview): longint; cdecl; external name 'cplayer_MakeMove';


constructor TMyPlayer.Init; 
begin 
  name:='C Randomak'; 
  message:=''; 
end;

destructor TMyPlayer.Done; 
begin 
end;

procedure TMyPlayer.InitGame(id: integer); 
begin 
  cplayer_InitGame(id);
end;

procedure TMyPlayer.Born(I_see: Tview); 
begin
  cplayer_Born(I_see);
end;

procedure TMyPlayer.Eaten(I_saw: Tview); 
begin 
  cplayer_Eaten(I_saw);
end;

procedure TMyPlayer.MakeMove(I_see: Tview; var command: integer); 
begin 
  command:=cplayer_MakeMove(I_see); 
end;
 
begin
  RegisterPlayer(New(PMyPlayer,Init));
end.
