#ifndef __CTYPES_H
#define __CTYPES_H

const MAX_PLAYERS 	= 4+4;

const MAX_PLAN_X  	= 20;
const MAX_PLAN_Y  	= 20;
const MAX_GAMES		= 1;
const MAX_ROUNDS	= 100;

#define MAX_VIEW 2
const MAX_HITS		= 3;

const DUR_Zrava  	= 7;
const DUR_Zmetena 	= 7;
const DUR_Neviditelna 	= 7;
    
const VAL_Zlata		= 1;
const VAL_Tyckova	= 3;

/* vselico */
const vNic		= 0x00000000L;
const vStena		= 0x00000001L;
const vSlimak		= 0x00000002L;
    
/*  fazulky */
const fTypes		= 7;
const vfAny		= 0x00000FF0L;
const vfZlata		= 0x00000010L;
const vfZrava		= 0x00000020L;
const vfTehlova		= 0x00000040L;
const vfZmetena		= 0x00000080L;
const vfNeviditelna	= 0x00000100L;
const vfTyckova		= 0x00000200L;
const vfOtaznik		= 0x00000400L;
    
/*  hraci */
const vPlayer		= 0x0F000000L;   
const vNiekto		= 0x0F000002L;   /* nejaky player alebo slimak */
    
const vPlayer1		= 0x01000000L;
const vPlayer2		= 0x02000000L;
const vPlayer3		= 0x04000000L;
const vPlayer4		= 0x08000000L;
    
/*  prikazy */
const cmdNic		= 0;
    
const cmdChodHore	= 1;
const cmdChodVpravo	= 2;
const cmdChodDole	= 3;
const cmdChodVlavo	= 4;
    
const cmdTehlujHore	= 5;
const cmdTehlujVpravo	= 6;
const cmdTehlujDole	= 7;
const cmdTehlujVlavo	= 8;


struct Tview {
    short x,y;
    int view[2*MAX_VIEW+1][2*MAX_VIEW+1];
};

#endif /* __CTYPES_H */
