#ifndef __CTYPES_H
#define __CTYPES_H

#define MAX_PLAYERS 	8

#define MAX_PLAN_X  	20
#define MAX_PLAN_Y  	20
#define MAX_GAMES	1
#define MAX_ROUNDS	100

#define MAX_VIEW 	2
#define MAX_HITS	3

#define DUR_Zrava  	7
#define DUR_Zmetena 	7
#define DUR_Neviditelna 7
    
#define VAL_Zlata	1
#define VAL_Tyckova	3

/* vselico */
#define vNic		0x00000000L
#define vStena		0x00000001L
#define vSlimak		0x00000002L
    
/*  fazulky */
#define fTypes		7
#define vfAny		0x00000FF0L
#define vfZlata		0x00000010L
#define vfZrava		0x00000020L
#define vfTehlova	0x00000040L
#define vfZmetena	0x00000080L
#define vfNeviditelna	0x00000100L
#define vfTyckova	0x00000200L
#define vfOtaznik	0x00000400L
    
/*  hraci */
#define vPlayer		0x0F000000L
   /* nejaky player alebo slimak */
#define vNiekto		0x0F000002L
    
#define vPlayer1	0x01000000L
#define vPlayer2	0x02000000L
#define vPlayer3	0x04000000L
#define vPlayer4	0x08000000L
    
/*  prikazy */
#define cmdNic		0
    
#define cmdChodHore	1
#define cmdChodVpravo	2
#define cmdChodDole	3
#define cmdChodVlavo	4
    
#define cmdTehlujHore	5
#define cmdTehlujVpravo	6
#define cmdTehlujDole	7
#define cmdTehlujVlavo	8

struct Tview {
    short x,y;
    int view[2*MAX_VIEW+1][2*MAX_VIEW+1];
    int score;
    short nZrava, nZmetena, nNeviditelna, nTehlova;
};

#endif /* __CTYPES_H */
