#include <stdio.h>
#include <stdlib.h>

char bitmap[320][240];

int main(int argc, char *argv[])
{
  FILE *f;
  char s[1000];
  int i,j;
  int x,y,iter;
  
  f=fopen("t1.aa","r");
  
  srand(7);
  
  j=0;
  while (!feof(f))
  {
    if (j>=240) break;
    fgets(s,sizeof(s),f);
    for (i=0;i<320;i++) bitmap[i][j]=s[i];
    j++;
  }
  
  fclose(f);
  fprintf(stderr,"AA file loaded...\n");

  printf("camera {\n   location <0,0,-12.3>\n   look_at <0,0,0>\n}\n\n");
  printf("light_source {\n   <2,2,-1>\n   color <2,2,2>\n}\n\n");
  printf("background {\n   color <0.0,0.0,0.0>\n}\n\n");

  if (argc>1)
  {
    sscanf(argv[1],"%d",&iter);
  } else iter=30000;
  
  fprintf(stderr,"Making %d iterations...\n",iter);

  for (i=0;i<iter;i++)
  {
    x=(int)(random()*1.0/RAND_MAX*320);
    y=(int)(random()*1.0/RAND_MAX*240);
    
    if (bitmap[x][y]<'A') printf("sphere {\n  <%.2lf,%.2lf,0>,%.2lf\n  pigment {\n    color <1,1,0.4>\n  }\n}\n",(x-160.0)/20,-(y-120.0)/20,0.1);
  }

  return 0;
}
