{ Proboj v1.3 by Darken (c) 2002 Latky-Polianky }

unit Player1;
 { ChrabroHLUB }

interface

uses Types;

const
  Bulhar1           = 16; { Istic }
  Bulhar2	    = 20; { na kolko % tehlujeme }



{$I headers.pp}



type
 
PHlubik = ^THlubik;
THlubik = object(TDefaultPlayer)

  constructor Init;
  destructor Done;
	
  procedure InitGame(id: integer); virtual;
 { zaciatok kazdej hry }
  procedure Born(I_see: Tview); virtual;

  procedure Eaten(I_saw: Tview); virtual;
  procedure MakeMove(I_see: Tview; var command: Integer); virtual;
   
end;

var
  HlubPtr           : PHlubik;
  Stack             : THlubStack;
  Queue		    : THlubQueue;
  Map,Len,Back      : TMap; 
  Hist		    : TMap;
  Ready             : Boolean;
  Changes	    : Longint;
  LastCom	    : Integer;
  CurView	    : TView;


implementation
uses crt
;


{$I engine.pp}


constructor THlubik.Init; 
begin 
  HlubPtr:=@self;  
  name:='The ChrabroHLUB'; 
  message:='Ty Hlubik !!!'; 
end;

destructor THlubik.Done; 
begin 
end;

procedure THlubik.InitGame(id: integer); 
var x,y             : Integer;
begin 
  for y:=0 to MAX_PLAN_Y+1 do
    for x:=0 to MAX_PLAN_X+1 do Map[x,y]:=vUnknown;

end;

procedure THlubik.Born(I_see: Tview); 
var Start           : PState_BASIC;
    Test	    : PState_EXPLORE;
    k		    : Integer;
begin 
  CurView:=I_see;
  Stack.Clear;
  new(Start,Init(ST_BASIC));
  Stack.Push(Start); 
  
  new(Test,Init(ST_EXPLORE));
  Stack.Push(Test);
   
 
 
end;

procedure THlubik.Eaten(I_saw: Tview); 
begin 
end;

{ procedure ShowHlubik;
 forward; }

procedure THlubik.MakeMove(I_see: TView; var command: Integer); 
var 
  Cur               : PState;
  St                : Integer;
  Eat		    : Boolean;
begin 
  CurView:=I_see;
  if ((CurView.nTehlova>0) and (Random(100)<=Bulhar2)) then Stack.Push(new(PState_TUNEL,Init(ST_TUNEL)));
  
  Stack.Push(new(PState_SAVEMAP,Init(ST_SAVEMAP)));
  
  Ready:=False; 
  repeat
    Cur:=Stack.Pop; 
 
    command:=Cur^.Run; 
    St:=Cur^.Typ; if (St=3) then Eat:=PState_MOVE(Cur)^.Eating;
    Dispose(Cur);
  until Ready;

 
 
 
 
 
 
  LastCom:=command;
 
end;

{procedure ShowHlubik;
var x,y: integer;
    l: longint;
    a,b: byte;
    c,d: char;
    s: string;
begin
  for y:=1 to MAX_PLAN_Y do
  begin
    gotoxy(1,y);
    for x:=1 to MAX_PLAN_X do
    begin
      l:=Map[x,y];
      s:='';
      
      if l and vStena<>0 then Put(s,'##',$77,$77)
      else
      begin
        c:=' '; a:=$07;
	d:=' '; b:=$07;
	
	if l and vfAny<>0 then c:='.';	
	if l and vfTyckova<>0 then a:=FoodCols[6];
	if l and vfOtaznik<>0 then a:=FoodCols[7];
	if l and vfZrava<>0 then a:=FoodCols[2];
	if l and vfTehlova<>0 then a:=FoodCols[3];
	if l and vfZmetena<>0 then a:=FoodCols[4];
	if l and vfNeviditelna<>0 then a:=FoodCols[5];
        if l and vfZlata<>0 then begin a:=FoodCols[1]; c:='*'; end;
	
	if l and vPlayer1<>0 then begin b:=PlayerCols[1]; d:='1'; end;
	if l and vPlayer2<>0 then begin b:=PlayerCols[2]; d:='2'; end;
	if l and vPlayer3<>0 then begin b:=PlayerCols[3]; d:='3'; end;
	if l and vPlayer4<>0 then begin b:=PlayerCols[4]; d:='4'; end;
	if l and vUnknown<>0 then begin b:=7; d:='x'; end; 
	if l and vSlimak<>0 then begin b:=$0F; d:='S'; end;

 
	
	Put(s,d+c,b,a);
      end;
      Put(s,'  ',$07,$07);
      
      textattr:=byte(s[1]); write(s[2]);
      textattr:=byte(s[3]); write(s[4]);
    end;
  end;
  
  textattr:=$07;
  writeln;
end;
}


begin
  RegisterPlayer(New(PHlubik,Init));
end.
