
{
  TODO: 
   - pri generovani novej pozicie hraca lepsie testovat, ci nebude niekde
     uzavrety
   - zvuky
   

  MISC:
   - $DEFINE INTRO   --   zapina intro/outro
}

  {$define INTRO}


program Proboj_CDman_aka_HarryPotter;
uses 
    types,
    vars,
    crt,

    display,
    {$IFDEF sound} esdpp, {$ENDIF}

    player1,
    player2,
    player3,
    player4,

    slimak2;




const
    LOG_FILE  = 'proboj.log';
    Xtab: array[0..15] of char = '0123456789ABCDEF';
    
    pls:array[1..MAX_PLAYERS] of longint = (vPlayer1, vPlayer2, vPlayer3, vPlayer4, vSlimak, vSlimak, vSlimak, vSlimak);

    MP3_name = 'music/music.mp3';
    MP3_name2 = 'music/outro.mp3';
    MP3_host = '';
 
    MP3backvol  = 127;
    MP3backfreq = 44100;

var magic: string;
    i,j,k: integer;
    b: byte;
    q_flag, game_no: integer;
    wait_time: integer;

    mp3id: longint;


procedure LogProboj;
var f:text;
    i: integer;
begin
  assign(f,LOG_FILE);
  {$I-}
  append(f);
  {$I+}
  if IOresult<>0 then rewrite(f);

  writeln(f,'--------------------------------------------------------------');
  writeln(f,' Proboj: Registered players:');
  for i:=1 to data^.players do writeln(f,'   ',data^.pl[i].name);
  writeln(f,'--------------------------------------------------------------');
  close(f);
end;

procedure LogS(s: string);
var f:text;
begin
  assign(f,LOG_FILE);
  append(f);
  writeln(f,s);
  close(f);
end;

procedure LogGame(game_no: integer);
var f:text;
begin
  assign(f,LOG_FILE);
  append(f);
  writeln(f,'Game ',game_no);

  write(f,' ');
  for i:=1 to vars.data^.players do write(f,' ',vars.data^.pl[i].score);
  writeln(f);

  close(f);
end;

procedure LogResults;
var f:text;
    i: integer;
begin
  assign(f,LOG_FILE);
  append(f);
  writeln(f,'Final results:');
  for i:=1 to vars.data^.players do
    writeln(f,'  Player ',i,' (',vars.data^.pl[i].name,'): ',vars.data^.pl[i].score,' points');
  writeln(f);
  close(f);
end;

procedure GenWalls(dat:Pdata);
var dx,dy,i,j,x,y: integer;
    fr:array[1..MAX_PLAN_X*MAX_PLAN_Y,1..2] of integer;
    fr_len, fr_pos: integer;
    ok: integer;
begin
  for i:=-MAX_VIEW+1 to MAX_PLAN_Y+MAX_VIEW do
   for j:=-MAX_VIEW+1 to MAX_PLAN_X+MAX_VIEW do dat^.plan[j,i]:=vStena;

  repeat
  write('.');
  for i:=2 to MAX_PLAN_Y-1 do
   for j:=2 to MAX_PLAN_X-1 do dat^.plan[j,i]:=vNic;

  { generate random walls }
  for i:=1 to round(MAX_PLAN_X*MAX_PLAN_Y*PROP_WALLS) do dat^.plan[random(MAX_PLAN_X)+1,random(MAX_PLAN_Y)+1]:=vStena;

  { mark all fields accessible from fr[1] }
  fr_len:=1; fr_pos:=1;
  for i:=2 to MAX_PLAN_Y-1 do
   for j:=2 to MAX_PLAN_X-1 do 
    if dat^.plan[j,i] and vStena=0 then
    begin
      fr[1,1]:=j;
      fr[1,2]:=i;
    end;

  while fr_pos<=fr_len do
  begin
    x:=fr[fr_pos,1];
    y:=fr[fr_pos,2];

    dat^.plan[x,y]:=dat^.plan[x,y] or $10000000;

    for dx:=-1 to 1 do
     for dy:=-1 to 1 do
     begin
       if ((dx*dy<>0) or (dx+dy=0)) then continue;
       
       if ((x+dx>=1) and (x+dx<=MAX_PLAN_X) and (y+dy>=1) and (y+dy<=MAX_PLAN_Y)
	    and (dat^.plan[x+dx,y+dy] and $10000000=0)
	    and (dat^.plan[x+dx,y+dy] and vStena=0)) then 
	    begin inc(fr_len); fr[fr_len,1]:=x+dx; fr[fr_len,2]:=y+dy;
		dat^.plan[x+dx,y+dy]:=dat^.plan[x+dx,y+dy] or $10000000; 
	    end;
      end;

    inc(fr_pos);  
  end;

  ok:=0;
  for i:=1 to MAX_PLAN_Y do
   for j:=1 to MAX_PLAN_X do
    if dat^.plan[j,i] and $10000000<>0 then inc(ok);

  until ok>0.5*MAX_PLAN_X*MAX_PLAN_Y;
end;

function RandomFood(ot:boolean):longint;
var t: longint;
begin
  if ot then
  begin
    case random(100) of
       0..39: t:=vfZlata;		{40%}
      40..49: t:=vfOtaznik;		{10%}
      50..59: t:=vfZrava;		{10%}
      60..69: t:=vfTehlova;		{10%}
      70..79: t:=vfZmetena;		{10%}
      80..89: t:=vfNeviditelna;		{10%}
      90..99: t:=vfTyckova;		{10%}
    end;
  end
  else
  begin
    case random(100) of
       0..49: t:=vfZlata;		{50%}
      50..59: t:=vfZrava;		{10%}
      60..69: t:=vfTehlova;		{10%}
      70..79: t:=vfZmetena;		{10%}
      80..89: t:=vfNeviditelna;		{10%}
      90..99: t:=vfTyckova;		{10%}
    end;
  end;
  RandomFood:=t;
end;

function RandomCommand: integer;
begin
  RandomCommand:=random(9);
end;

procedure GenFood(dat:Pdata; count:integer);
var i,x,y: integer;
    t,cnt: longint;
begin
  for i:=1 to count do
  begin
    cnt:=0;
    repeat
      x:=random(MAX_PLAN_X)+1;
      y:=random(MAX_PLAN_Y)+1;
      if cnt>1000 then break;
      inc(cnt);
    until ((dat^.plan[x,y] and vStena=0) and    { nie je tam stena }
           (dat^.plan[x,y] and vfAny=0) and	{ nie je tam fazulka }
	   (dat^.plan[x,y] and vNiekto=0));	{ nikto tam nie je }
    
    dat^.plan[x,y]:=dat^.plan[x,y] or RandomFood(true);

    inc(actions);
    action[actions].cmd:=2;
    action[actions].x:=x;
    action[actions].y:=y;

  end;
end;

procedure GetView(dat:Pdata; var view:Tview; id:integer);
var dx,dy: integer;
begin
  view.x:=dat^.pl[id].x;
  view.y:=dat^.pl[id].y;
  
  view.score:=dat^.pl[id].score;
  view.nZrava:=dat^.pl[id].nZrava;
  view.nZmetena:=dat^.pl[id].nZmetena;
  view.nNeviditelna:=dat^.pl[id].nNeviditelna;
  view.nTehlova:=dat^.pl[id].nTehlova;
  
  for dy:=-MAX_VIEW to MAX_VIEW do
   for dx:=-MAX_VIEW to MAX_VIEW do
   begin
     view.view[dx,dy]:=dat^.plan[view.x+dx,view.y+dy] and $0FFFFFFF;

     { umaz z pohladu vsetkych prave-neviditelnych }
     if ((view.view[dx,dy] and vPlayer1<>0) and (dat^.pl[1].nNeviditelna>0) and (1<>id)) then view.view[dx,dy]:=view.view[dx,dy] and not vPlayer1; 
     if ((view.view[dx,dy] and vPlayer2<>0) and (dat^.pl[2].nNeviditelna>0) and (2<>id)) then view.view[dx,dy]:=view.view[dx,dy] and not vPlayer2; 
     if ((view.view[dx,dy] and vPlayer3<>0) and (dat^.pl[3].nNeviditelna>0) and (3<>id)) then view.view[dx,dy]:=view.view[dx,dy] and not vPlayer3; 
     if ((view.view[dx,dy] and vPlayer4<>0) and (dat^.pl[4].nNeviditelna>0) and (4<>id)) then view.view[dx,dy]:=view.view[dx,dy] and not vPlayer4; 
   end;
end;

procedure GenPlayer(dat:Pdata; id:integer);
var x,y: integer;
    view: Tview;
begin
  repeat
    x:=random(MAX_PLAN_X)+1;
    y:=random(MAX_PLAN_Y)+1;
  until ((dat^.plan[x,y] and vNiekto=0) and     { nikto tam nie je }
	 (dat^.plan[x,y] and vfAny=0) and	{ ziadna fazulka }
	 (dat^.plan[x,y] and vStena=0) and	{ nie je tam stena }
         (dat^.plan[x,y] and $10000000<>0)); 	{ je to vo vacsej casti planu }

  dat^.plan[x,y]:=dat^.plan[x,y] or pls[id];
  dat^.pl[id].x:=x;
  dat^.pl[id].y:=y;
  dat^.pl[id].dir:=0;

  GetView(dat,view,id);
  vars.Invalidate(magic);
  dat^.pl[id].obj^.Born(view);
  vars.Validate(magic);
end;

function Opposite(dir:integer):integer;
begin
  case dir of
    cmdChodHore: 	Opposite:=cmdChodDole;
    cmdChodDole: 	Opposite:=cmdChodHore;
    cmdChodVpravo: 	Opposite:=cmdChodVlavo;
    cmdChodVlavo: 	Opposite:=cmdChodVpravo;
    else Opposite:=cmdNic;
  end;
end;

function GetDir(cmd:integer): integer;
begin
  case cmd of
    cmdChodHore,   cmdTehlujHore:   GetDir:=0;
    cmdChodVpravo, cmdTehlujVpravo: GetDir:=1;
    cmdChodDole,   cmdTehlujDole:   GetDir:=2;
    cmdChodVlavo,  cmdTehlujVlavo:  GetDir:=3;
    else GetDir:=0;
  end;
end;

{*****************************************************************************}
{*****************************************************************************}
{*****************************************************************************}
{*****************************************************************************}
procedure Game(game_no: integer);
var dat: Pdata;
    m,i,j,k: integer;
    view:Tview;
    command: integer;
    q,x,y,dx,dy: integer;
    l: longint;
    
    canmove, eaten: array[1..MAX_PLAYERS] of boolean;
    s:string;
    
begin
  dat:=vars.data;
  
  { init players for this game }
  vars.Invalidate(magic);
  for i:=1 to dat^.players do 
  begin
    dat^.pl[i].obj^.InitGame(i);
    dat^.pl[i].left:=MAX_HITS;
    dat^.pl[i].nZrava:=0;
 
    dat^.pl[i].nNeviditelna:=0;
    dat^.pl[i].nZmetena:=0;
    dat^.pl[i].nTehlova:=0;
 
  end;
  vars.Validate(magic);

  { init plan }
  GenWalls(dat);
  GenFood(dat,round(MAX_PLAN_X*MAX_PLAN_Y*PROP_FOOD));
  for i:=1 to dat^.players do GenPlayer(dat,i);

  { show screen }  

  ShowGameNo(game_no);
  ShowPlan(dat,false);

  for i:=1 to 4 do ShowData(dat,i);
  for i:=1 to 4 do begin GetView(data,view,i); ShowView(view,6*(i-1)+1); end;

  for m:=1 to MAX_ROUNDS do
  begin
    q:=0;  { kolko fazuliek sa zozerie }

    actions:=0;   { no. of graphical actions }

    { 0.9 slimaci su makaci... }
    for i:=5 to dat^.players do
    begin
      dat^.pl[i].nZrava:=7;
      dat^.pl[i].left:=7;
    end;

    { 1. zistit tahy vsetkych (zivych) }
    for i:=1 to dat^.players do
    begin
      GetView(dat,view,i);
      command:=cmdNic;
      
      if dat^.pl[i].left>0 then
      begin
        vars.Invalidate(magic);
        dat^.pl[i].obj^.MakeMove(view, command);
        vars.Validate(magic);
      end;
      
      if dat^.pl[i].nZmetena>0 then dat^.pl[i].cmd:=RandomCommand
    			       else dat^.pl[i].cmd:=command;

      dat^.pl[i].dir:=GetDir(dat^.pl[i].cmd);      
      
      canmove[i]:=true;
      eaten[i]:=false;
    end;

    { 1.1 otestovat, ci bol hrac i zozrany pocas presunu a ci moze ist tam, kde chce }
    for i:=1 to dat^.players do
    begin
      if dat^.pl[i].left<=0 then continue;
      dx:=0;
      dy:=0;
      x:=dat^.pl[i].x;
      y:=dat^.pl[i].y;
      
      case dat^.pl[i].cmd of
        cmdChodHore:    begin dx:= 0; dy:=-1; end;
	cmdChodDole:	begin dx:= 0; dy:= 1; end;
	cmdChodVpravo:	begin dx:= 1; dy:= 0; end;
	cmdChodVlavo: 	begin dx:=-1; dy:= 0; end;
      end;
      
      { do steny sa ist neda }
      if dat^.plan[x+dx,y+dy] and vStena<>0 then canmove[i]:=false;

      { ak nechceme nikam ist, tak netreba testovat zjedenie }
      if dx+dy<>0 then
      begin
        { niekto bol na policku, kam chceme ist }      
        if dat^.plan[x+dx,y+dy] and vNiekto<>0 then
        begin
          for j:=1 to dat^.players do
	  begin
            if dat^.pl[j].left<=0 then continue;
	    if i=j then continue;
	    { ak je vedla (i.e. kam chce i ist) hrac j, je zravy a chce ist
	      tam, kde je prave i, tak i bude zozrany }
  	    if ((dat^.pl[j].x=x+dx) and (dat^.pl[j].y=dy+y) 
	        and (dat^.pl[j].nZrava>0) 
	        and (dat^.pl[j].cmd=Opposite(dat^.pl[i].cmd))) then
	    begin
	      if j>4 then
	      begin
	        if dat^.pl[i].nZrava>0 then   { slimak nezozerie zeruceho hraca }
				       else eaten[i]:=true;
	      end
	      else
	      begin
	        { j je hrac a zerie, takze i bude zozrany }
	        eaten[i]:=true;
	      end;
	    end;
	  end;
        end;
      end;
    end;

    { 1.2 vykonat tahy (tych, co neboli zozrani), pripisat fazulky }
    { 1.2.1 umaz vsetkych hracov z planu }
    for i:=1 to dat^.players do
    begin
      if dat^.pl[i].left<=0 then continue;
      dat^.plan[dat^.pl[i].x,dat^.pl[i].y]:=dat^.plan[dat^.pl[i].x,dat^.pl[i].y] and not pls[i];

      inc(actions);
      action[actions].cmd:=1;  { clear }
      action[actions].x:=dat^.pl[i].x;
      action[actions].y:=dat^.pl[i].y;

    end;
    
    { 1.2.2 posun hracov, pripis fazulky }
    for i:=1 to dat^.players do
    begin
      if dat^.pl[i].left<=0 then continue;
      if ((canmove[i]) and (not eaten[i])) then
      begin
        dx:=0;
        dy:=0;
        x:=dat^.pl[i].x;
        y:=dat^.pl[i].y;
      
        case dat^.pl[i].cmd of
          cmdChodHore:   begin dx:= 0; dy:=-1; end;
	  cmdChodDole:	 begin dx:= 0; dy:= 1; end;
	  cmdChodVpravo: begin dx:= 1; dy:= 0; end;
	  cmdChodVlavo:  begin dx:=-1; dy:= 0; end;
        end;
	
	{ zmaz hraca zo starej pozicie }
 
	{ posun hraca }
	dat^.pl[i].x:=x+dx;
	dat^.pl[i].y:=y+dy;
	{ pridaj hraca na novu poziciu }
 
	
	{ pridaj fazulky }
	if i<=4 then   { slimakom fazulky nechutia }
	begin
    	  l:=dat^.plan[x+dx,y+dy];
	  { ak je tam vfOtaznik, tak prigeneruj nahodnu fazulku }
	  if l and vfOtaznik<>0 then l:=l or RandomFood(false);
	
	  if l and vfZlata<>0 then begin inc(dat^.pl[i].score,VAL_Zlata); inc(q); end;
	  if l and vfZrava<>0 then begin inc(dat^.pl[i].nZrava,DUR_Zrava); inc(q); end;
	  if l and vfTehlova<>0 then begin inc(dat^.pl[i].nTehlova); inc(q); end;
	  if l and vfZmetena<>0 then begin inc(dat^.pl[i].nZmetena,DUR_Zmetena); inc(q); end;
	  if l and vfNeviditelna<>0 then begin inc(dat^.pl[i].nNeviditelna,DUR_Neviditelna); inc(q); end;
	  if l and vfTyckova<>0 then begin dec(dat^.pl[i].score,VAL_Tyckova); inc(q); end;
	
	  { zmaz fazulky z policka }
	  dat^.plan[x+dx,y+dy]:=dat^.plan[x+dx,y+dy] and not vfAny;
	end
	else
	begin
	  { prekresli policko, odkial odisiel slimak (mozu tam byt fazulky) } 

    	  inc(actions);
          action[actions].cmd:=2;
          action[actions].x:=x;
          action[actions].y:=y;

	end;
      end;
    end;
    
    { 1.2.3 nakresli vsetkych hracov na plan }
    for i:=1 to dat^.players do
    begin
      if dat^.pl[i].left<=0 then continue;
      dat^.plan[dat^.pl[i].x,dat^.pl[i].y]:=dat^.plan[dat^.pl[i].x,dat^.pl[i].y] or pls[i];

      inc(actions);
      action[actions].cmd:=2;  { kresli panacika }
      action[actions].x:=dat^.pl[i].x;
      action[actions].y:=dat^.pl[i].y;

    end;

    { 1.2.4 vykonat tehlovanie, ak sa da }
    for i:=1 to dat^.players do
    begin
      if dat^.pl[i].cmd>=cmdTehlujHore then
      begin
        dx:=0;
        dy:=0;
        x:=dat^.pl[i].x;
        y:=dat^.pl[i].y;
      
        case dat^.pl[i].cmd of
          cmdTehlujHore:   begin dx:= 0; dy:=-1; end;
	  cmdTehlujDole:   begin dx:= 0; dy:= 1; end;
	  cmdTehlujVpravo: begin dx:= 1; dy:= 0; end;
	  cmdTehlujVlavo:  begin dx:=-1; dy:= 0; end;
        end;
	
	{ ak na x+dx,y+dy nikto nie je }
	if dat^.plan[x+dx,y+dy] and vNiekto=0 then 
	  { a ak to nie je na kraji planu }
	  if ((x+dx>1) and (x+dx<MAX_PLAN_X) and (y+dy>1) and (y+dy<MAX_PLAN_Y)) then
	    { a ak dotycny moze tehlovat }
	    if dat^.pl[i].nTehlova>0 then
	    begin
	      dec(dat^.pl[i].nTehlova);
	      if dat^.plan[x+dx,y+dy] and vStena=0 then dat^.plan[x+dx,y+dy]:=vStena
	    					   else dat^.plan[x+dx,y+dy]:=vNic;

	      inc(actions);
	      action[actions].cmd:=3;  { tehlovanie }
	      action[actions].x:=x+dx;
	      action[actions].y:=y+dy;

	    end;
      end;
    end;
    
    { 1.3 skontroluj, ci niekto niekoho nezozral svojim prichodom na policko }
    for i:=1 to dat^.players do
    begin
      if dat^.pl[i].left<=0 then continue;
      if dat^.pl[i].nZrava>0 then  { ak i zerie }
      begin
        for j:=1 to dat^.players do  { ci i zozral j }
	begin
	  if i=j then continue;   { sameho seba zrat necheme... }
          if dat^.pl[j].left<=0 then continue;   { mrtvoly nam nechutia... }
	  
	  if ((dat^.pl[i].x=dat^.pl[j].x) and (dat^.pl[i].y=dat^.pl[j].y)) then
	  begin
	    { ak i je slimak, }
	    if i>4 then
	    begin
	      if dat^.pl[j].nZrava>0 then   { tak ak j zerie, tak j nie je zozrany } 
	    			     else eaten[j]:=true; 
	    end
	    else
	    begin
	      eaten[j]:=true;
	    end;
	  end;
	end;
      end;
    end;

    { 2. zmaz zozranych a vytvor novych }
    for i:=1 to dat^.players do
    begin
      if dat^.pl[i].left<=0 then continue;
      if eaten[i] then
      begin
        x:=dat^.pl[i].x;
        y:=dat^.pl[i].y;
	
	{ zmaz z planu }
        dat^.plan[x,y]:=dat^.plan[x,y] and not pls[i];

        inc(actions);
        action[actions].cmd:=1;  { clear }
        action[actions].x:=x;
        action[actions].y:=y;

	if dat^.plan[x,y] and vNiekto<>0 then
	begin
          inc(actions);
          action[actions].cmd:=2;
          action[actions].x:=x;
          action[actions].y:=y;
	end;

	dec(dat^.pl[i].left);
	{ vytvor noveho hraca, ak ma este zivot }
	if dat^.pl[i].left>0 then 
	begin
	  GenPlayer(dat,i);

          inc(actions);
          action[actions].cmd:=2;  { kresli panacika }
          action[actions].x:=dat^.pl[i].x;
          action[actions].y:=dat^.pl[i].y;

	end;
 
      end;
    end;

    { 2.1 uber neviditelnost/zravost/zmetenost hracom }
    for i:=1 to dat^.players do
    begin
      if dat^.pl[i].left<=0 then continue;
      
      if dat^.pl[i].nZrava>0 then dec(dat^.pl[i].nZrava);
      if dat^.pl[i].nZmetena>0 then dec(dat^.pl[i].nZmetena);
      if dat^.pl[i].nNeviditelna>0 then dec(dat^.pl[i].nNeviditelna);
    end;

    { 2.2 vygenerovat nove fazulky }
    GenFood(dat,q);
 
 
 
 

    { 9.9 obnov obrazovku }
 
    ShowActions(dat);
    for i:=1 to 4 do 
      if eaten[i] then ShowData(dat,i,false)
    		  else ShowData(dat,i,true);
     
    for i:=1 to 4 do begin GetView(data,view,i); ShowView(view,6*(i-1)+1); end;

    { 9.99 klavesnica, delay }
    if keypressed then
      case readkey of
        'Q' : begin q_flag:=3; break; end;
	'0' : wait_time:=0;
	'1' : wait_time:=10;
	'2' : wait_time:=20;
	'3' : wait_time:=30;
	'4' : wait_time:=40;
	'5' : wait_time:=50;
	'6' : wait_time:=60;
	'7' : wait_time:=70;
	'8' : wait_time:=80;
	'9' : wait_time:=90;
	'-' : wait_time:=125;
	'=' : wait_time:=247;
      end;    
      
    delay(wait_time);

  end;

  LogGame(game_no);
end;

begin
  writeln('Proboj 2002 (1): Harry Potter a Slimaci');

  { step 0.1: magic generation }
  magic:=''; randomize;
  for i:=1 to 64 do 
  begin
    b:=random(256);    
    magic:=Xtab[b shr 4]+Xtab[b and 15];
  end;
  if not vars.SetMagic(magic) then Error('Somebody has changed my magic!');

  { step 0.2: prepare vars.data }
  if not vars.Validate(magic) then Error('Validate failed!');
  vars.data^.players:=0;
  
  { step 0.3: re-register players }
  types.RegisterAll(magic);
  writeln('Registered players:');
  for i:=1 to data^.players do writeln('  ',data^.pl[i].name);

  { step 0.9: init graphics, load musk file, prepare logfile }

  {$IFDEF sound} 
    Mp3Init; 
    Mp3Host(MP3_host);
  {$ENDIF}

  disp_Init;
  LogProboj;

  { step 0.99: init something more }
  q_flag:=0;
  game_no:=0;
  wait_time:=100;

  { step 0.995: intro }

  {$IFDEF INTRO}
    kdelay(1000);
    DrawPCX('pcx/warning.pcx',0,0,200,50,-1); kdelay(5000); DrawColor(0); kdelay(500);
    DrawPCX('pcx/provedbyCL.pcx',180,194,200,50,0); kdelay(3000); DrawColor(0); kdelay(500);
  {$ENDIF}

  {$IFDEF sound}
    MP3frequency(MP3backfreq);
    mp3id:=MP3play(MP3_name,MP3backvol,MP3backvol,7);
  {$ENDIF}
  
  {$IFDEF INTRO}
    kdelay(1000);
    DrawPCX('pcx/inoutro/intro_1.pcx',0,0,200,50,-1); kdelay(3000); DrawColor(0); kdelay(500);
    DrawPCX('pcx/inoutro/intro_2.pcx',0,0,200,50,-1); kdelay(3000); DrawColor(0); kdelay(500);
    DrawPCX('pcx/inoutro/intro_3.pcx',0,0,200,50,-1); kdelay(3000); DrawColor(0); kdelay(500);
    DrawPCX('pcx/inoutro/intro_4.pcx',0,0,200,50,-1); kdelay(3000); DrawColor(0); kdelay(500);
    DrawColor(0);
    
    DrawPCX('pcx/logo/logo5.pcx',0,0,100,50,-1);    kdelay(300);
    DrawPCX('pcx/logo/logo10.pcx',0,0,100,150,-1);  kdelay(300);
    DrawPCX('pcx/logo/logo20.pcx',0,0,100,50,-1);   kdelay(300);
    DrawPCX('pcx/logo/logo30.pcx',0,0,100,150,-1);  kdelay(300);
    DrawPCX('pcx/logo/logo40.pcx',0,0,100,50,-1);   kdelay(300);
    DrawPCX('pcx/logo/logo60.pcx',0,0,100,150,-1);  kdelay(300);
    DrawPCX('pcx/logo/logo80.pcx',0,0,100,50,-1);   kdelay(300);
    DrawPCX('pcx/logo/logo100.pcx',0,0,100,150,-1); kdelay(300);
    DrawPCX('pcx/logo/logo150.pcx',0,0,100,50,-1);  kdelay(300);
    DrawPCX('pcx/logo/logo200.pcx',0,0,100,150,-1); kdelay(300);
    DrawPCX('pcx/logo/logo250.pcx',0,0,100,50,-1);  kdelay(300);
    DrawPCX('pcx/logo/logo300.pcx',0,0,100,150,-1); kdelay(300);

    kdelay(5000);
    DrawColor(0);

  {$ENDIF}
  
  LoadImages;

  
  { step 1.0: start game, each pair twice }
  for game_no:=1 to MAX_GAMES do Game(game_no);

  { step 1.1: show results }
  LogResults;
  if ((q_flag=0) or (q_flag=3)) then
  begin

    CrossColor(0);

 

    {$IFDEF sound}
    { fade out background sound }
    for i:=15 downto 0 do
      MP3Volume(mp3id,8*i,8*i);
    
    { stop game background sound }
    MP3Stop(mp3id);

    mp3id:=MP3play(MP3_name2,MP3backvol,MP3backvol,7);
    {$ENDIF}

    ShowResults;
    DrawColor(0);
    
    {$IFDEF INTRO}
    DrawPCX('pcx/inoutro/outro_1.pcx',0,0,200,50,-1); kdelay(7000); DrawColor(0); kdelay(500);
    DrawPCX('pcx/inoutro/outro_2.pcx',0,0,200,50,-1); kdelay(7000); DrawColor(0); kdelay(500);
    DrawPCX('pcx/inoutro/outro_3.pcx',0,0,200,50,-1); kdelay(7000); DrawColor(0); kdelay(500);
    DrawPCX('pcx/inoutro/outro_4.pcx',0,0,200,50,-1); kdelay(7000); DrawColor(0); kdelay(500);
    DrawPCX('pcx/inoutro/outro_5.pcx',0,0,200,50,-1); kdelay(7000); DrawColor(0); kdelay(500);
    DrawPCX('pcx/inoutro/outro_6.pcx',0,0,200,50,-1); kdelay(7000); DrawColor(0); kdelay(500);
    DrawPCX('pcx/inoutro/outro_7.pcx',0,0,200,50,-1); kdelay(7000); DrawColor(0); kdelay(500);
    DrawPCX('pcx/inoutro/outro_8.pcx',0,0,200,50,-1); kdelay(7000); DrawColor(0); kdelay(500);
    {$ENDIF}
    
    CrossPCX('pcx/ksplogo.pcx',20,100);

    {$IFDEF sound}
    { stop results and outro sound }
    while Mp3IsPlaying(mp3id) do if kdelay(300) then break;
    MP3Stop(mp3id);
    {$ENDIF}

  end;
  
  { step 1.99: done graphics }
  disp_Done;
end.
