unit Slimak1;

interface
uses Types;
      
type TMyPlayer = object(TDefaultPlayer)
			constructor Init;
			destructor Done;
			
			{ zaciatok kazdej hry }
			procedure InitGame(id: integer); virtual;
					   
			{ znovunarodenie (i.e. po InitGame a po kazdom zozrati }
			procedure Born(I_see: Tview); virtual;
			
			{ po zozrati }
			procedure Eaten(I_saw: Tview); virtual;
			
			{ jeden tah }
			procedure MakeMove(I_see: Tview; var command: integer); virtual;

			private
			  dir: integer;
		      end;
     PMyPlayer = ^TMyPlayer;


implementation

constructor TMyPlayer.Init; 
begin 
  name:='Slimak 1.0';
  message:=''; 
end;

destructor TMyPlayer.Done; 
begin 
end;

procedure TMyPlayer.InitGame(id: integer); 
begin 
  dir:=0;
end;

procedure TMyPlayer.Born(I_see: Tview); 
begin 
end;

procedure TMyPlayer.Eaten(I_saw: Tview); 
begin 
end;

procedure TMyPlayer.MakeMove(I_see: Tview; var command: integer); 
var dx,dy:integer;
    cmd,max: integer;
begin 
  command:=cmdNic;
 
  
  case dir of
    0 : {Up}    begin dx:=0; dy:=-1; cmd:=cmdChodHore; end;
    1 : {Right} begin dx:=1; dy:=0; cmd:=cmdChodVpravo; end;
    2 : {Down}  begin dx:=0; dy:=1; cmd:=cmdChodDole; end;
    3 : {Left}  begin dx:=-1; dy:=0; cmd:=cmdChodVlavo; end;
  end;
  
  { podla moznosti chod tak, ako isiel predtym }
  if I_see.view[dx,dy] and vStena=0 then command:=cmd
  else 
  begin
    max:=0;
    repeat
      if ((I_see.view[0,-1] and vStena=0) and (random(7)=1)) then command:=cmdChodHore;
      if ((I_see.view[1,0] and vStena=0) and (random(7)=1)) then command:=cmdChodVpravo;
      if ((I_see.view[0,1] and vStena=0) and (random(7)=1)) then command:=cmdChodDole;
      if ((I_see.view[-1,0] and vStena=0) and (random(7)=1)) then command:=cmdChodVlavo;
      inc(max);
    until ((command<>cmdNic) or (max>100));
  end;
  
  case command of
    cmdChodHore :   dir:=0;
    cmdChodVpravo : dir:=1;
    cmdChodDole :   dir:=2;
    cmdChodVlavo :  dir:=3;
  end;
end;
 
begin
  RegisterPlayer(New(PMyPlayer,Init));
  RegisterPlayer(New(PMyPlayer,Init));
  RegisterPlayer(New(PMyPlayer,Init));
  RegisterPlayer(New(PMyPlayer,Init));
end.
