unit Vars;

interface
uses types;

{ store all private data here; during players'' moves, this will point 
  to nowhere }
var data: PData;

function SetMagic(s:string): boolean;
function Validate(s:string): boolean;
function InValidate(s:string): boolean;

implementation
var magic: string;
    valid_data: PData;
    invalid_data: PData;

{ magic can be changed to sth else than '' only once }
function SetMagic(s:string): boolean;
begin
  SetMagic:=false;
  if ((magic='') and (data=Ptr(7,7))) then 
  begin
    magic:=s;
    SetMagic:=true;
  end;
end;

function Validate(s:string): boolean;
begin
  Validate:=false;
  if ((s=magic) and (magic<>'')) then 
  begin
    data:=valid_data;
    Validate:=true;
  end;
end;

function InValidate(s:string): boolean;
begin
  InValidate:=false;
  if ((s=magic) and (magic<>'')) then 
  begin
    data:=invalid_data;
    InValidate:=true;
  end;
end;
    
begin
  magic:='';
  new(valid_data);
  invalid_data:=nil;
  data:=ptr(7,7);
end.
