{ ENGINE Implementatzion v1.3 by Darken (c) 2002 Latky-Polianky }

{ ---------------------- T S t a t e   D e f ---------------------------- }
constructor TState.Init(T : Integer); 
begin Typ:=T; end;
{ ----------------------------------------------------------------------- }
destructor TState.Done; begin end;
{ ----------------------------------------------------------------------- }
function TState.Run : Integer; 
begin
  case Typ of
    ST_BASIC   : Run:=PState_BASIC(@self)^.Exec;
    ST_SAVEMAP : Run:=PState_SAVEMAP(@self)^.Exec;
    ST_MOVE    : Run:=PState_MOVE(@self)^.Exec;
    ST_EXPLORE : Run:=PState_EXPLORE(@self)^.Exec;
    ST_TUNEL   : Run:=PState_TUNEL(@self)^.Exec;
 
  end;
end;
{ ----------------------------------------------------------------------- }



{ ---------------------- R a n d o m   M o v e -------------------------- }
function RandomMove : Integer;
var 
  istic,k           : Integer;
  cx,cy		    : Integer;
begin
  istic:=0; cx:=CurView.X; cy:=CurView.Y;
  repeat 
    k:=Random(4); Inc(istic);
  until (((CurView.View[dx[k],dy[k]] and (vStena or vfTyckova or vfOtaznik or vfZmetena or VSlimak)) = 0) 
{        (((k+2) mod 4)<>(LastCom-1)) } or (istic>bulhar1));
  RandomMove:=k+1;
end;
{ ----------------------------------------------------------------------- }

{ ----------------------------- Check Eat ------------------------------- }

{ ----------------------------------------------------------------------- }

{ ---------------------- Check Eat ------------------------ }
function CheckEat : Integer;
var
  cx,cy             : Longint;
  mx,my,mlen,l	    : Longint;
  TestMove	    : PState_MOVE;
 
begin
  new(TestMove,Init(ST_MOVE));
 
  mlen:=Infty; 
  for cy:=-MAX_VIEW to MAX_VIEW do 
    for cx:=-MAX_VIEW to MAX_VIEW do if ((CurView.View[cx,cy] and (vfZlata or vfZrava or vfTehlova or vfNeviditelna)) > 0) then begin
      l:=TestMove^.Setpath(CurView.x+cx,CurView.y+cy);
      if ((l>=0) and (l<mlen)) then begin
        mlen:=l; mx:=CurView.x+cx; my:=CurView.y+cy;
      end;
    end;
    
  if (mlen<Infty) then begin
    TestMove^.SetPath(mx,my);
    TestMove^.Eating:=True;
    TestMove^.Explore:=False;
    Stack.Push(TestMove);
    CheckEat:=1;
  end else CheckEat:=0;
end;
{ ----------------------------------------------------------------------- }

{ ---------------------- Defense ------------------------ }
{function Defense : Integer;
var
  cx,cy             : Longint;
  mx,my,mlen,l	    : Longint;
  TestMove	    : PState_MOVE;
 
begin
 
 
 
  for cy:=-MAX_VIEW to MAX_VIEW do 
    for cx:=-MAX_VIEW to MAX_VIEW do if ((CurView.View[cx,cy] and (vSlimak)) > 0) then begin
      
    end;
    
  if (mlen<Infty) then begin
    TestMove^.SetPath(mx,my);
    TestMove^.Eating:=True;
    TestMove^.Explore:=False;
    Stack.Push(TestMove);
    CheckEat:=1;
  end else CheckEat:=0;
end;}
{ ----------------------------------------------------------------------- }



{ ---------------------- T S t a t e   B a s i c ------------------------ }
function TState_BASIC.Exec : Integer;
var 
  NewSelf         : PState_BASIC;
{  NahodnyPohyb    : PState_MOVE;
  k		  : Integer;}
begin
 
  Exec:=cmdNic;
 
  new(NewSelf); NewSelf^:=self;
  Stack.Push(NewSelf); 
  Ready:=True; 
end;
{ ----------------------------------------------------------------------- }

{ ---------------------- T S t a t e   S a v e M a p -------------------- }
function TState_SAVEMAP.Exec : Integer;
var
  dtx,dty,cx,cy       : Integer;
begin
  Exec:=0; Changes:=0; cx:=CurView.x; cy:=CurView.y;
  for dty:=-MAX_VIEW to MAX_VIEW do
    for dtx:=-MAX_VIEW to MAX_VIEW do begin 
      if (Map[cx+dtx,cy+dty] <> vUnknown) then 
        Changes:=Changes or (Map[cx+dtx,cy+dty] xor CurView.View[dtx,dty]);
      Map[cx+dtx,cy+dty]:=CurView.View[dtx,dty]
    end;
end;
{ ----------------------------------------------------------------------- }


{ ---------------------- T S t a t e   M o v e -------------------------- }
function TState_MOVE.SetPath(X,Y : Integer) : Integer;
var 
  Found             : Boolean;
  cx,cy		    : Integer;
  i,j,k	            : Integer;
begin
  Precount:=False; Eating:=False;
  for cy:=0 to MAX_PLAN_Y+1 do 
   for cx:=0 to MAX_PLAN_X+1 do Len[cx,cy]:=Infty;
   
  Queue.Init; 
  Queue.Push(CurView.X,CurView.Y); Found:=False;
  Len[CurView.X,CurView.Y]:=0; Back[CurView.X,CurView.Y]:=-1;

  repeat
    Queue.Pop(cx,cy); 
    if (cx=X) and (cy=Y) then Found:=True else
    for k:=0 to 3 do 
      if ((Map[cx+dx[k],cy+dy[k]] and (vStena or vUnknown or vfTyckova or vfZmetena or vfOtaznik)) = 0) and 
         (Len[cx,cy]+1 < Len[cx+dx[k],cy+dy[k]]) then begin
	   Back[cx+dx[k],cy+dy[k]]:=(k+2) mod 4;
	   Len[cx+dx[k],cy+dy[k]]:=Len[cx,cy]+1;
	   Queue.Push(cx+dx[k],cy+dy[k]);
	 end;
  until (Queue.Empty or Found);

  if Found then begin
    PLen:=Len[X,Y]; cx:=X; cy:=Y; PPtr:=1; 
    dstX:=X; dstY:=Y;
    for k:=1 to PLen do begin
      Path[PLen-k+1]:=(Back[cx,cy]+2) mod 4;
      i:=Back[cx,cy]; 
      cx:=cx+dx[i];
      cy:=cy+dy[i];
    end;
    SetPath:=PLen; Precount:=True;
 
 
 
  end else begin
    PLen:=0;
    SetPath:=-1;
  end;
end;

{ -------------------------------------------------- }

function TState_MOVE.Exec: Integer;
var NewSelf         : PState_MOVE;
var px,py	    : Integer;
begin
  if (PPtr>PLen) then begin
    Ready:=False; exit;
  end;
  
  NewSelf:=nil;
  if ((Changes and (vStena or vfTyckova or vfZmetena or vfOtaznik))>0) then begin 
    Precount:=False; Changes:=0;
  end;
  if (not Precount) then begin
    if (SetPath(dstX,dstY)<=0) then begin
 
      Exec:=RandomMove;
      Ready:=True;
      exit;   
    end else begin
 
    end;
  end;

 
 
 

  
  Exec:=Path[PPtr]+1; Inc(PPtr);
  if (PPtr<=PLen) then begin
    new(NewSelf); NewSelf^:=self;
    Stack.Push(NewSelf); 
  end;

  if (not Eating) and (CheckEat>0) then begin
    if (NewSelf<>nil) then begin 
      NewSelf^.Precount:=False; 
      if (Explore) then NewSelf^.PPtr:=PLen+1;
    end;
    Ready:=False; exit;
  end;
    
  Ready:=True; 
end;
{ ----------------------------------------------------------------------- }



{ ---------------------- T S t a t e   T u n e l ------------------------ }
function TState_TUNEL.Exec : Integer;
var
  k                 : Integer;
begin
  Ready:=False;
  for k:=0 to 3 do if (CurView.View[dx[k],dy[k]] and vStena > 0) then begin
    Exec:=5+k; Ready:=True; Break;
  end;
end;
{ ----------------------------------------------------------------------- }


{ ---------------------- T S t a t e   E x p l o r e -------------------- }

function TState_EXPLORE.Exec: Integer;
var NewSelf         : PState_EXPLORE;
    NewMove         : PState_MOVE;
    Found	    : Boolean;
    k,i		    : Integer;    
begin
  new(NewSelf); NewSelf^:=self;
  Stack.Push(NewSelf); Found:=False;

  if (Random(100)>60) then begin

    new(NewMove,Init(ST_MOVE)); i:=0;
    repeat
      Inc(i); k:=Random(4);
      if (NewMove^.SetPath(CurView.x+MAX_VIEW*(dx[k]+dx[(k+1)mod 4]),CurView.y+MAX_VIEW*(dy[k]+dy[(k+1)mod 4]))>=0) then begin
        NewMove^.Eating:=False; 
        NewMove^.Explore:=True; 
        Stack.Push(NewMove); Found:=True;
      end;  
    until (Found or (i>Bulhar1));
{  for k:=0 to 3 do if NewMove^.SetPath(CurView.x+MAX_VIEW*(dx[k]+dx[(k+1)mod 4]),CurView.y+MAX_VIEW*(dy[k]+dy[(k+1)mod 4])) then begin
    Stack.Push(NewMove); Found:=True; Break;
  end;    }
  end;
  if (not Found) then begin
    Exec:=RandomMove; Ready:=True;
  end else Ready:=False;
end;

{ ----------------------------------------------------------------------- }



{ ---------------------- H L U B   Q u e u e ---------------------------- }
procedure THlubQueue.Init;
begin Head:=0; Tail:=0; end;

procedure THlubQueue.Push(X,Y : Integer);
begin
  Data[Tail].X:=X; Data[Tail].Y:=Y;
  Tail:=Tail+1; if (Tail>QueueSize) then Tail:=0;
 
end;

procedure THlubQueue.Pop(var X : Integer;var Y : Integer);
begin
  X:=Data[Head].X; Y:=Data[Head].Y;
  Head:=Head+1; if (Head>QueueSize) then Head:=0;
 
end;

function THlubQueue.Empty : Boolean;
begin 
  Empty:=(Head=Tail);
end;
{ ----------------------------------------------------------------------- }




{ ---------------------- H L U B   S t a c k ---------------------------- }
procedure THlubStack.Clear;
var i : Integer;
begin
  for i:=1 to Head do dispose(Data[i],Done); 
  Head:=0;
end;
{ ----------------------------------------------------------------------- }
procedure THlubStack.Init;
begin 
  Head:=0; 
end;
{ ----------------------------------------------------------------------- }
procedure THlubStack.Push(S : PState);  { neosetrene stack overflow }
begin
  Inc(Head); Data[Head]:=S; 
end;
{ ----------------------------------------------------------------------- }
function THlubStack.Pop : PState; { neosetrene pop empty }
begin
  if (Head>0) then begin
    Pop:=Data[Head]; Dec(Head);
  end else Pop:=nil;
end;
{ ----------------------------------------------------------------------- }
function THlubStack.Empty : Boolean;
begin
  Empty:=(Head=0);
end;
{ ----------------------------------------------------------------------- }



