unit esdpp;

interface

{$LINKLIB c}
{$LINKLIB esd}
{$LINK esdcamel}

procedure MP3Init;cdecl; external name 'MP3Init';
procedure __MP3Host(s:pchar);cdecl; external name 'MP3Host';
procedure MP3Frequency(f:longint);cdecl; external name 'MP3Frequency';
function MP3Finished:boolean;cdecl; external name 'MP3Finished';
function MP3Play(s:pchar; l,r,predelay:longint):longint;cdecl; external name 'MP3Play';
function MP3PlayLoop(s:pchar; l,r,predelay:longint):longint;cdecl; external name 'MP3PlayLoop';
function MP3Stop(id:longint):longint;cdecl; external name 'MP3Stop';
function MP3Volume(id,l,r:longint):longint;cdecl; external name 'MP3Volume';
function MP3IsPlaying(id:longint):boolean;cdecl; external name 'MP3IsPlaying';
function WAVLoad(filename:pchar;freq:double):longint;cdecl; external name 'WAVLoad';
function SamplePlay(id,l,r:longint):longint;cdecl; external name 'SamplePlay';
function SampleLoop(id,l,r:longint):longint;cdecl; external name 'SampleLoop';
function SampleStop(id:longint;now:boolean):longint;cdecl; external name 'SampleStop';
function SampleUnload(id:longint):longint;cdecl; external name 'SampleUnload';

procedure MP3Host(s:string);

implementation
var esd_host: string;

procedure MP3Host(s:string);
begin
  if s='' then exit;
  esd_host:=s+#0;
  __MP3Host(@esd_host[1]);
end;

end.

