unit Player2;

interface
uses Types;
      
type TMapa = array[-3..3,-3..3] of longint;
     TMyPlayer = object(TDefaultPlayer)
			constructor Init;
			destructor Done;
			
			{ zaciatok kazdej hry }
			procedure InitGame(id: integer); virtual;
					   
			{ znovunarodenie (i.e. po InitGame a po kazdom zozrati }
			procedure Born(I_see: Tview); virtual;
			
			{ po zozrati }
			procedure Eaten(I_saw: Tview); virtual;
			
			{ jeden tah }
			procedure MakeMove(I_see: Tview; var command: integer); virtual;
                        
			LastCmd: integer;
			
			Map: array[0..MAX_PLAN_X+1, 0..MAX_PLAN_Y+1] of integer;
			mapka: Tmapa;
			V_TEHLUJ: integer;
		      end;
     PMyPlayer = ^TMyPlayer;


implementation
uses crt;

constructor TMyPlayer.Init; 
begin 
  name:='Slizolin'; 
  message:=''; 
end;

destructor TMyPlayer.Done; 
begin 
end;

procedure TMyPlayer.InitGame(id: integer); 
begin 
end;

procedure TMyPlayer.Born(I_see: Tview); 
var i,j: integer;
begin 
  gotoxy(1,24);
  write('Born at ',I_see.x,',',I_see.y,'     ');
  lastcmd:=cmdNic;
  for i:=0 to MAX_PLAN_X+1 do
   for j:=0 to MAX_PLAN_Y+1 do 
    begin    
      map[i,j]:=0;
      if (i=0) or (j=0) or (i=MAX_PLAN_X+1) or (j=MAX_PLAN_Y+1) then 
       map[i,j]:=-maxint;
    end;  

end;

procedure TMyPlayer.Eaten(I_saw: Tview); 
begin 
end;

procedure TMyPlayer.MakeMove(I_see: Tview; var command: integer); 
const 
      V_STENA = -7000;
      V_SLIMAK = -16000;
      V_PLAYER = -500;
      
      V_NEVIDCOEFF = 5;
      V_TEHLUJDEF = -800;
      
      V_ZLATA = 3000;
      V_NEVIDITELNA = 200;
      V_ZRAVA = 300;
      V_TEHLOVA = 500;
      
      V_ZMETENA = -500;
      
      V_TYCKOVA = -3000;
      V_OTAZNIK = -200;
      
      V_RETURN = -100; { ze ci sa vrati odkial prave dosiel}
      V_RET2 = -100;  {ze ci sa vratio tam kde uz bol v tejto hre }
      V_RESTORE = 80; { prirastok pri navstiveni policka }
      
      V_RANDOM = 4; { ze o kolko je nahodne }
      

var w:char;
    s,j,v,z: integer;
    ii,jj: integer;
    

  
  function DefaultValue(a: longint; var zla: boolean): integer;
  var v: integer;
  begin
    v:=0;
    if (a and vStena)<>0 then v:=v+V_STENA;
    if (a and vSlimak)<>0 then
     begin
       if (I_see.nZrava=0) and (I_see.nNeviditelna=0) then v:=v+V_SLIMAK;
       if (I_see.nNeviditelna<>0) then v:=v+(V_SLIMAK div V_NEVIDCOEFF);
     end;  
    
    if ((a and vPlayer1)<>0) or 
       ((a and vPlayer3)<>0) or 
       ((a and vPlayer4)<>0) then 
       begin
         if I_see.nZrava=0 then v:=v+V_PLAYER else v:=v-(V_PLAYER*I_see.nZrava);
       end;	 

    if (a and vfZlata)<>0 then v:=v+V_ZLATA; 
    if (a and vfZrava)<>0 then v:=v+V_ZRAVA; 
    if (a and vfTehlova)<>0 then v:=v+V_TEHLOVA; 
    if (a and vfZmetena)<>0 then v:=v+V_ZMETENA; 
    if (a and vfNeviditelna)<>0 then v:=v+V_NEVIDITELNA; 
    if (a and vfTyckova)<>0 then v:=v+V_TYCKOVA; 
    if (a and vfOtaznik)<>0 then v:=v+V_OTAZNIK; 
    
    zla:=true;
    if (a and vStena)<>0 then zla:=false;
    if (a and vSlimak)<>0 then zla:=false; 
    if (a and vfZlata)<>0 then zla:=false; 
    if (a and vfZrava)<>0 then zla:=false; 
    if (a and vfTehlova)<>0 then zla:=false;  
    if (a and vfNeviditelna)<>0 then zla:=false;  
    
    defaultvalue:=v;
  end;
  
  function value(x,y: integer; a: TMapa): integer;
  type TBod = record
                x,y: integer;
              end;
  var prezrete: array[-3..3,-3..3] of boolean;
      values: array[-3..3,-3..3] of integer;
  
      f: array[1..1000] of TBod;
      i,j,ii,jj,z,k: integer;			       
      val: integer;
      zla: boolean;
      tx,ty: integer;
  begin
    for i:=-2 to 2 do for j:=-2 to 2 do values[i,j]:=0; { vynuluj }     
    z:=1;
    k:=0;
    for i:=-2 to 2 do 
     for j:=-2 to 2 do
      if (a[i,j] and vStena)=0 then { steny nerobime } 
       begin
         for ii:=-2 to 2 do for jj:=-2 to 2 do prezrete[ii,jj]:=false; { vynuluj }     
         val:=DefaultValue(a[i,j],zla) + ((map[I_see.x+i,I_see.y+j] div V_RESTORE)*V_RET2);
	 prezrete[i,j]:=true;
	 inc(k); {push prvy bod}
	 f[k].x:=i;
	 f[k].y:=j;
	 
	 repeat

	   
	   { pop }
	   tx:=f[z].x;
	   ty:=f[z].y;
	   z:=z+1;
	   if z>800 then 
	    begin
	      gotoxy(1,24);
	      writeln('Overflow');
 
	    end;
	   
	   inc(values[tx,ty],val);
	   if zla then val:=0;
	   val:=val div 2; { idema na dalsie policko -> zniz hodnotu }

	   
	   if (tx<2) and ((a[tx+1,ty] and vStena)=0) 
	   and (not prezrete[tx+1,ty]) then begin { push ten vpravo }
 	                                                prezrete[tx+1,ty]:=true;
	                                                k:=k+1; 
							f[k].x:=tx+1;
							f[k].y:=ty;		
	                                               end;
 	  if (tx>-2) and ((a[tx-1,ty] and vStena)=0) 
	  and (not prezrete[tx-1,ty]) then begin { push ten vlavo }
	                                                     prezrete[tx-1,ty]:=true;
	                                                     k:=k+1; 
						    	     f[k].x:=tx-1;
							     f[k].y:=ty;		
	                                                   end;
	  if (ty>-2) and ((a[tx,ty-1] and vStena)=0) 
	  and (not prezrete[tx,ty-1]) then begin { push ten hore }
	                                                     prezrete[tx,ty-1]:=true;
	                                                     k:=k+1; 
							     f[k].x:=tx;
							     f[k].y:=ty-1;		
	                                                   end;
	  if (ty<2) and ((a[tx,ty+1] and vStena)=0) 
	  and (not prezrete[tx,ty+1]) then begin { push ten dole }
	                                                    prezrete[tx,ty+1]:=true;
	                                                    k:=k+1; 
							    f[k].x:=tx;
							    f[k].y:=ty+1;		
	                                                  end;
	 until z>k;
       end;
       value:=values[x,y];
  end;
  
  

  function zbuchaj(s,j,v,z: integer): integer;
  var cmd: integer;
  begin    
    if (s>=j) and (s>=v) and (s>=z) then cmd:=cmdChodHore;
    if (j>=s) and (j>=v) and (j>=z) then cmd:=cmdChodDole;
    if (z>=j) and (z>=v) and (z>=s) then cmd:=cmdChodVlavo;
    if (v>=j) and (v>=s) and (v>=z) then cmd:=cmdChodVpravo;
    
    if (cmd=cmdChodHore) and ((I_see.view[0,-1] and vStena)<>0) then cmd:=cmdTehlujHore;
    if (cmd=cmdChodDole) and ((I_see.view[0, 1] and vStena)<>0) then cmd:=cmdTehlujDole;
    if (cmd=cmdChodVlavo) and ((I_see.view[-1,0] and vStena)<>0) then cmd:=cmdTehlujVlavo;
    if (cmd=cmdChodVpravo) and ((I_see.view[1,0] and vStena)<>0) then cmd:=cmdTehlujVpravo;
    zbuchaj:=cmd;
  end;
  
begin 
  with I_see do
   if nTehlova>0 then V_TEHLUJ:=V_TEHLUJDEF div nTehlova else V_TEHLUJ:=V_TEHLUJDEF;
  
  command:=cmdNic; 
  with I_see do
   begin
     for ii:=-2 to 2 do { skopiruj mapku }
      for jj:=-2 to 2 do
       begin
         mapka[ii,jj]:=view[ii,jj];
       end;
     
     if ((view[ 0,-1] and vStena)<>0) then s:=V_STENA else s:=value(0,-1,mapka);
     if ((view[ 0,-1] and vStena)<>0) and (nTehlova>0) then
      begin
        mapka[ 0,-1]:=mapka[ 0,-1] - vStena;
	s:=value(0,-1,mapka)+V_TEHLUJ;
	mapka[ 0,-1]:=mapka[ 0,-1] + vStena;
      end; 
     if ((view[ 0, 1] and vStena)<>0) then j:=V_STENA else j:=value(0, 1,mapka);
     if ((view[ 0, 1] and vStena)<>0) and (nTehlova>0) then
      begin
        mapka[ 0, 1]:=mapka[ 0, 1] - vStena;
	j:=value(0, 1,mapka)+V_TEHLUJ;
	mapka[ 0, 1]:=mapka[ 0, 1] + vStena;
      end; 
     if ((view[ 1, 0] and vStena)<>0) then v:=V_STENA else v:=value(1, 0,mapka);
     if ((view[ 1, 0] and vStena)<>0) and (nTehlova>0) then
      begin
        mapka[ 1, 0]:=mapka[ 1, 0] - vStena;
	v:=value(1, 0,mapka)+V_TEHLUJ;
	mapka[ 1, 0]:=mapka[ 1, 0] + vStena;
      end; 
     if ((view[-1, 0] and vStena)<>0) then z:=V_STENA else z:=value(-1, 0,mapka);
     if ((view[-1, 0] and vStena)<>0) and (nTehlova>0) then
      begin
        mapka[-1,0]:=mapka[-1,0] - vStena;
	z:=value(-1,0,mapka)+V_TEHLUJ;
	mapka[-1,0]:=mapka[-1,0] + vStena;
      end; 
     
     case lastcmd of
       cmdChodHore: inc(j,V_RETURN);
       cmdChodDole: inc(s,V_RETURN);
       cmdChodVlavo: inc(v,V_RETURN);
       cmdChodVpravo: inc(z,V_RETURN);
     end;
     
    
   end;
  
  command:=zbuchaj(s,j,v,z);   
  lastcmd:=command;
  
  map[I_see.x, I_see.y]:=map[I_see.x, I_see.y]+V_RESTORE; {zapis na mapu ze som kde som }
  for ii:=0 to MAX_PLAN_X+1 do
   for jj:=0 to MAX_PLAN_Y+1 do
    begin
      if map[ii,jj]<>0 then dec(map[ii,jj]);
    end; 

  gotoxy(1,24);

{  write('(',s,',',j,',',v,',',z,')');
  
  case command of
    cmdChodHore:    write(' Idem hore');
    cmdChodDole:    write('Idem dole');
    cmdChodVlavo:   write('Idem vlavo');
    cmdChodVpravo:  write('Idem vpravo');
  end;

  with I_see do
  begin
   write(' ',map[x+0,y-1],' ');
   write(map[x+0,y+1],' ');
   write(map[x+1,y+0],' ');
   write(map[x-1,y+0],'             ');
  end;
 } 
{  if keypressed then w:=readkey;
  case w of
    'q' : halt;  
  end;
}
end;
 
begin
  RegisterPlayer(New(PMyPlayer,Init));
end.
